#version 330 core

in vec3 vPos[];
in vec3 fColor[];
uniform vec4 cRange;
out vec3 fCol;
out float Dec;

float PIE = 3.1415926535;


//-----------------------------------
void tudeRst(inout float, inout float, float, int);///ok
void all_tudeRst_0(inout vec4 vect, vec3 locT);///ok
void all_tudeRst_1(inout vec4 vect, vec3 locT);///ok
vec3 eucToTude(vec4 vecT);	 ///ok
vec4 tudeToEuc(vec3 locT);
float pyth2(float x, float y);
float pyth3(float x, float y, float z);
float atan2(float x, float y);

//-----------------------------------

void tudeRst(inout float vec_1, inout float vec_2, float locT, int mode)///ok
{//-- ,o,[Zbg]
	float tRot = atan2(vec_1, vec_2);
	float R = pyth2(vec_1, vec_2);
	if(0==mode){
		vec_1 = R * sin(tRot - locT);
		vec_2 = R * cos(tRot - locT);
	}else{
		vec_1 = R * sin(tRot + locT);
		vec_2 = R * cos(tRot + locT);
	}
}
void all_tudeRst_0(inout vec4 vect, vec3 locT)///ok
{//-- ,o,[Zbg]
		tudeRst(vect.x, vect.y, locT.x, 0);//-- X-Y ]
		tudeRst(vect.y, vect.z, locT.y, 0);//-- Y-Z ]
		tudeRst(vect.z, vect.w, locT.z, 0);//-- Z-W ]
}
void all_tudeRst_1(inout vec4 vect, vec3 locT)///ok
{//-- ,o,[Zbg]
		tudeRst(vect.z, vect.w, locT.z, 1);//-- Z-W ]
		tudeRst(vect.y, vect.z, locT.y, 1);//-- Y-Z ]
		tudeRst(vect.x, vect.y, locT.x, 1);//-- X-Y ]
}
vec3 eucToTude(vec4 vecT){	 ///ok
	vec3 locT;
	locT.x = atan2(vecT.x, vecT.y);								
	locT.y = atan2(pyth2(vecT.x,vecT.y), vecT.z);	
	locT.z = atan2(pyth3(vecT.x,vecT.y,vecT.z), vecT.w);

	return locT;
}
vec4 tudeToEuc(vec3 locT){	// [,o,[]W[XYZ]WWɕϊ
	vec4 vecT = vec4( 
				 sin(locT.z) * sin(locT.y) * sin(locT.x),//X
				 sin(locT.z) * sin(locT.y) * cos(locT.x),//Y
				 sin(locT.z) * cos(locT.y),		//Z
				 cos(locT.z)	//W
	);
	return vecT;
}
float pyth2(float x, float y){ return sqrt(pow(x,2)+pow(y,2)); }///ok
float pyth3(float x, float y, float z){ return sqrt(pow(x,2)+pow(y,2)+pow(z,2)); }///ok
float atan2(float x, float y){///ok
	float deg = atan(x / y); deg += PIE*float(y<0);
	return deg;
}
//--------------


void main(){

	
		vec3 curPt = vPos[0];
		float length = tan(curPt.y);
		float scX = length * sin(curPt.x);
		float scY = length * cos(curPt.x);
		scX = (scX + cRange[0]) / (cRange[0] + cRange[1]) * 2 - 1;
		scY = (scY + cRange[3]) / (cRange[2] + cRange[3]) * 2 - 1;

		float dec;
		if(curPt.y<0.5*PIE) dec = (PIE-curPt.z*0.5) /PIE; else dec = curPt.z*0.5 /PIE;
		Dec = dec;
	
		gl_Position = vec4(scX, scY, 0, 1);
		fCol = fColor[0];//-- Fݒ
		
		EmitVertex();
		EndPrimitive();
}

